﻿section YeeofficeConnector;

client_id ="18e3f376-5cfd-1ed1-770f-ba933a6041d1";
client_secret = "f52df1a2-d4ee-c8be-38fc-6fc7aa2a3836";
redirect_uri = "https://oauth.powerbi.com/views/oauthredirect.html";
windowWidth = 600;
windowHeight = 700;
shared OpenApi="https://apps.yeeoffice.cn";
shared loginURL="https://login.yeeoffice.cn";


pageSize=100;
[DataSource.Kind="YeeofficeConnector",Publish="YeeofficeConnector.UI"]
shared YeeofficeConnector.Contents =  CreateApplications;



DefaultRequestHeaders  =
 let
   
   kind = Extension.CurrentCredential()[AuthenticationKind],  
   headers = if (kind = "Key") then [  
        #"apikey" = Extension.CurrentCredential()[Key],
        #"Accept" = "application/json",
        #"Content-Type" = "application/json" 
    ] else [  
        #"Accept" = "application/json",
        #"Content-Type" = "application/json" 
    ]
in
    headers;


 
 LoadListFields=(ListID as text,AppID as text) as table => 
        let 
        apiUrl = Text.Format("#{0}/openapi/v1/lists/#{1}/#{2}/fields", {OpenApi, AppID, ListID}),
        source =loadWebContext(apiUrl,[ Headers = DefaultRequestHeaders]),
        json = Json.Document(source),
        data = json[Data],
        toTable = Table.FromRecords(data,{"FieldName", "DisplayName"})
         in
    toTable;

 GetData = (pageindex as number,ListID as text,AppID as text) =>
    let
       apiUrl = Text.Format("#{0}/openapi/v1/lists/#{1}/#{2}/items/query?columnType=0", {OpenApi, AppID, ListID}),
       parameters =Text.Format("{'pageIndex':#{0},'pageSize':#{1},'FilterValue':'','SortsList':[],'Wheres':[]}", {pageindex, pageSize}),
     options = [
        Headers = DefaultRequestHeaders,
        Content = Text.ToBinary(parameters)
     ],
     value = loadWebContext(apiUrl,options), 
     json = Json.Document(value),
     Data =json[Data],  
     TotalCount=json[TotalCount],
     PageCount = (TotalCount + pageSize -1)/pageSize,
     PageIndex=if(PageCount>= (pageindex))then pageindex else 0
    in
    Data meta [PageIndex=PageIndex];

  FunctionCallThatReturnsATable = (ListID as text,AppID as text) as table =>
    let
     fields=LoadListFields(ListID,AppID), 
     rename=Table.ToRows(fields), 
     Pagination = List.Generate( 
            ()=>[Result = try GetData(1,ListID,AppID)otherwise null, PageIndex = Value.Metadata(Result)[PageIndex]],
            each  [PageIndex]> 0,
            each  [Result=try GetData([PageIndex]+1,ListID,AppID) otherwise null, PageIndex = Value.Metadata(Result)[PageIndex]], 
            each  [Result]),
      ToTable = Table.FromRecords(List.Combine(Pagination)),  
      listtable= Table.RenameColumns(ToTable,rename,MissingField.Ignore),
      newtable = Table.RenameColumns(listtable, {{"TenantID","s_TenantID"},{"AppID","s_AppID"},{"ListID","s_ListID"},{"RowVersion","s_RowVersion"}}) 
    in
     newtable;

 loadWebContext=(url as text,options)=>
let
    web=  Web.Contents(Function.InvokeAfter(()=>url, #duration(0,0,0,0.2)),options)
in
    web;

//加载自定义APP
 LoadList=(key as text,appid as text)=>
     let 
       url=Text.Format("#{0}/openapi/v1/applications/#{1}/lists?appID=#{2}", {OpenApi, key,appid}),
       options=[Headers = DefaultRequestHeaders  ],
       source =loadWebContext(url,options),
       json = Json.Document(source),
       data = json[Data],
       toTable = Table.FromRecords(data,{"Title", "ListID"}), 
       newtable = Table.RenameColumns(toTable, { {"Title", "Name"},{"ListID", "Key"}}), 
       a= Table.AddColumn(newtable,"ItemKind", each "Table"), 
       b= Table.AddColumn(a,"ItemName", each "Table"),
       c= Table.AddColumn(b,"IsLeaf", each true),  
       d= Table.AddColumn(c,"Data", each FunctionCallThatReturnsATable([Key],appid))
    in
     d;

 Load30Applications=()=>
     let 
        url=Text.Combine({OpenApi,"/openapi/v1/applications?appID=30"}),
       options=[Headers = DefaultRequestHeaders  ],
       source =loadWebContext(url,options), 
       json = Json.Document(source),
       data = json[Data],
       toTable = Table.FromRecords(data,{"Title", "ListID"}), 
       newtable = Table.RenameColumns(toTable, { {"Title", "Name"},{"ListID", "Key"}}), 
       a= Table.AddColumn(newtable,"ItemKind", each "Folder"), 
       b= Table.AddColumn(a,"ItemName", each "Folder"),
       c= Table.AddColumn(b,"IsLeaf", each false),  
       d= Table.AddColumn(c,"Data", each CreateListTable([Key],"30"))
    in
     d;
 //流程中心
 Load41Applications=()=>
     let 
       url=Text.Combine({OpenApi,"/openapi/v1/applications?appID=41"}),
       options=[Headers = DefaultRequestHeaders  ],
       source =loadWebContext(url,options), 
       json = Json.Document(source),
       data = json[Data],
       toTable = Table.FromRecords(data,{"Title", "ListID"}), 
       newtable = Table.RenameColumns(toTable, { {"Title", "Name"},{"ListID", "Key"}}), 
       a= Table.AddColumn(newtable,"ItemKind", each "Folder"), 
       b= Table.AddColumn(a,"ItemName", each "Folder"),
       c= Table.AddColumn(b,"IsLeaf", each false),  
       d= Table.AddColumn(c,"Data", each CreateListTable([Key],"41"))  // 
    in
     d;
CreateApplications= ()  =>
    let  
      objects = #table({"Name","Key","Data","ItemKind", "ItemName", "IsLeaf"},{ }),
      f=Table.Combine({objects,Load30Applications(),Load41Applications()}),
      navTable  = Table.ToNavigationTable(f, {"Key"}, "Name", "Data", "ItemKind", "ItemName", "IsLeaf") 
    in
  navTable;


 CreateListTable = (key as text,appid as text) as table => 
    let
       list= LoadList(key,appid),
       objects = #table({"Name","Key","Data","ItemKind", "ItemName", "IsLeaf"},{ }),
       f=Table.Combine({objects,list}),
       navTable = Table.ToNavigationTable(f, {"Key"}, "Name", "Data", "ItemKind", "ItemName", "IsLeaf")
    in
        navTable;
 Table.ToNavigationTable = (
    table as table,
    keyColumns as list,
    nameColumn as text,
    dataColumn as text,
    itemKindColumn as text,
    itemNameColumn as text,
    isLeafColumn as text
) as table =>
    let
        tableType = Value.Type(table),
        newTableType = Type.AddTableKey(tableType, keyColumns, true) meta 
        [
            NavigationTable.NameColumn = nameColumn, 
            NavigationTable.DataColumn = dataColumn,
            NavigationTable.ItemKindColumn = itemKindColumn, 
            Preview.DelayColumn = itemNameColumn, 
            NavigationTable.IsLeafColumn = isLeafColumn
        ],
        navigationTable = Value.ReplaceType(table, newTableType) 
    in
        navigationTable;
 
YeeofficeConnector = [
    connection = (dataSourcePath) => {"YeeofficeConnector.Contents", dataSourcePath},
    Authentication = [ 
        OAuth = [
            StartLogin = StartLogin,
            FinishLogin = FinishLogin,
            Refresh = Refresh
           
        ],
        Key = [  ]
        ],
    Label = Extension.LoadString("YeeofficeAuthenticationLabel")
];





YeeofficeConnector.UI = [
    Beta = true, 
    ButtonText = { Extension.LoadString("YeeofficeFormulaTitle"), Extension.LoadString("FormulaHelp") },
    LearnMoreUrl = "https://www.yeeoffice.cn/",
    SourceImage = YeeofficeConnector.Icons,
    SourceTypeImage = YeeofficeConnector.Icons
];

YeeofficeConnector.Icons = [
    Icon16 = { Extension.Contents("YeeofficeConnector16.png"), Extension.Contents("YeeofficeConnector20.png"), Extension.Contents("YeeofficeConnector24.png"), Extension.Contents("YeeofficeConnector32.png") },
    Icon32 = { Extension.Contents("YeeofficeConnector32.png"), Extension.Contents("YeeofficeConnector40.png"), Extension.Contents("YeeofficeConnector48.png"), Extension.Contents("YeeofficeConnector64.png") }
];
 
//开始登录
StartLogin = (clientApplication, dataSourcePath, state, display) => 
  let
AuthorizeUrl =  Text.Combine({loginURL,"/connect/authorize?"}) & Uri.BuildQueryString([
    client_id = client_id,
    scope = "openid  basic_api profile offline_access",
    response_type="code",
    state = state,
    redirect_uri = redirect_uri])
in
[
    LoginUri = AuthorizeUrl,
    CallbackUri = redirect_uri,
    WindowHeight = windowHeight,
    WindowWidth = windowWidth,
    Context = null
];    

//完成登录
FinishLogin = (clientApplication, dataSourcePath, context, callbackUri, state) => 
     let
        Parts = Uri.Parts(callbackUri)[Query]
    in
        TokenMethod(Parts[code]);
//刷新Token
Refresh = (clientApplication, dataSourcePath, oldCredential) => 
    let
       Response = Web.Contents( Text.Combine({loginURL,"/connect/token"}), [
            Content = Text.ToBinary(Uri.BuildQueryString([
                client_id = client_id,
                client_secret = client_secret, 
                grant_type="refresh_token",
                refresh_token=oldCredential[refresh_token]
               ])),
            Headers=[#"Content-type" = "application/x-www-form-urlencoded",#"Accept" = "application/json"]]),
        Parts = Json.Document(Response)
    in
      Parts;

//获取Token
TokenMethod = (code) =>
    let
        Response = Web.Contents(Text.Combine({loginURL,"/connect/token"}), [
            Content = Text.ToBinary(Uri.BuildQueryString([
                client_id = client_id,
                client_secret = client_secret,
                code = code,
                grant_type="authorization_code",
                redirect_uri = redirect_uri])),
            Headers=[#"Content-type" = "application/x-www-form-urlencoded",#"Accept" = "application/json"]]),
        Parts = Json.Document(Response)
    in
        Parts;
 